import torch
from torch import nn
from torch.utils.data import DataLoader
from torchvision import datasets
from torchvision.transforms import ToTensor
from mpl_toolkits.axes_grid1 import ImageGrid
from torchvision.utils import save_image, make_grid
import matplotlib.pyplot as plt

# Download training data from open datasets.
training_data = datasets.MNIST(
	root="data",
	train=True,
	download=False,
	transform=ToTensor(),
)

# Download test data from open datasets.
test_data = datasets.MNIST(
	root="data",
	train=False,
	download=False,
	transform=ToTensor(),
)


batch_size = 100

# Create data loaders.
# train_dataloader = DataLoader(training_data, batch_size=batch_size, shuffle=True )
train_dataloader = DataLoader(training_data, batch_size=batch_size )
test_dataloader = DataLoader(test_data, batch_size=batch_size, shuffle=False )

# device = torch.device("cuda" if torch.cuda.is_available() else "cpu")
# device = torch.device("mps" if torch.cuda.is_available() else "cpu")
device = "cpu"


#  get 25 sample training images for visualization
dataiter = iter(train_dataloader)
image = next( dataiter )

num_samples = 25
sample_images = [image[0][i,0] for i in range(num_samples)] 

fig = plt.figure(figsize=(5, 5))
grid = ImageGrid(fig, 111, nrows_ncols=(5, 5), axes_pad=0.1)

for ax, im in zip(grid, sample_images):
	ax.imshow(im, cmap='gray')
	ax.axis('off')

plt.show()
